<template>
  <div class="vertical-menu-panel flex-grow-0 flex-column" v-bind:class="displayClass">
    <!-- not minimized -->
    <div v-if="!minimized" class="d-flex flex-grow-1 flex-column">
      <div class="bg-primary d-flex flex-row py-3">
        <h1 class="text-light my-0 py-2 px-3 flex-grow-1">
          <span class="mr-2">
            <font-awesome-icon icon="layer-group"></font-awesome-icon>
          </span>
          {{ title }}
        </h1>
        <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="minimized = true">
          <font-awesome-icon icon="angle-left"></font-awesome-icon>
        </button>
        <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="close">
          <font-awesome-icon icon="times"></font-awesome-icon>
        </button>
      </div>

      <div class="d-flex flex-grow-1 flex-row">
        <div class="layer-group-list d-flex flex-grow-1 flex-column bg-light">
          <div v-for="group in layerGroups" :key="createUniqueId(group)">
            <button class="btn btn-light btn-block text-left"
              :class="isActiveGroup(group.id)"
              @click="currentGroup = group.id">
              {{ group.title }}
            </button>
          </div>
        </div>
        <div class="layer-list d-flex flex-grow-1 flex-column px-2 py-2">
          <layer-checkbox v-for="layer in currentLayers" :key="createUniqueId(layer)"
            :layer="layer.id"
            :icon="layer.icon">
          </layer-checkbox>
        </div>
      </div>
    </div>

    <!-- minimized -->
    <div v-else class="d-flex flex-grow-1 flex-column">
      <div class="bg-primary d-flex flex-row py-3">
        <button class="btn text-light flex-grow-0 mx-auto close-btn" @click="minimized = false">
          <font-awesome-icon icon="layer-group"></font-awesome-icon>
        </button>
      </div>

      <div class="d-flex flex-grow-1 flex-row">
        <div class="layer-list-minimized d-flex flex-grow-1 flex-column px-2 py-2">
          <layer-checkbox v-for="layer in currentLayers" :key="createUniqueId(layer)"
            :layer="layer.id"
            :icon="layer.icon"
            :notext="true">
          </layer-checkbox>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import LayerCheckbox from './LayerCheckbox'
import { createUniqueId } from '@/core/util'


export default {
  name: 'layerverticalpanel',

  props: {
    title: {
      type: String,
      default: 'Camadas'
    },
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      currentGroup: 0,
      minimized: false,
    }
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    currentPanel: {
      get() {
        return this.$store.state.workspaces[this.workspace].ui.currentPanel
      }
    },

    layerGroups: {
      get() {
        return this.$store.state.layerGroups
      }
    },

    layers: {
      get() {
        return this.$store.state.layers
      }
    },

    currentLayers: {
      get() {
        return this.layers.filter((layer) => {
          return this.isLayerInCurrentGroup(layer)
        })
      },
    },

    displayClass: {
      get() {
        return this.currentPanel === this.name ? 'd-flex' : 'd-none'
      }
    },
  },

  methods: {
    close() {
      //this.$store.commit(mutationNameResolve(this.workspace, CHANGE_PANEL), { panel: this.name })
    },

    isActiveGroup(group) {
      return {
        active: group === this.currentGroup,
      }
    },

    isLayerInCurrentGroup(layer) {
      return layer.groups.includes(this.currentGroup)
    },

    createUniqueId() {
      return createUniqueId()
    },
  },

  mounted() {
    this.currentGroup = this.layerGroups[0].id
  },

  components: {
    LayerCheckbox,
  },
}
</script>

<style scoped>
.vertical-menu-panel {
  font-size: 0.8em;
  line-height: 1.8em;
}

.vertical-menu-panel h1 {
  font-weight: lighter;
}

.vertical-menu-panel button.btn.close-btn {
  border-radius: 2rem;
  height: max-content;
  width: max-content;
  margin-top: auto;
  margin-bottom: auto;
}

.vertical-menu-panel button.btn.close-btn:hover {
  background-color: #008eff !important;
}

.layer-group-list {
  min-width: 10rem !important;
}

.layer-group-list button.btn {
  border-radius: 0;
}

.layer-list {
  min-width: 15rem !important;
}

.layer-list hr {
  height: 1px;
  border: 0;
  border-top: 1px solid #ccc;
  margin: 1em 0;
  padding: 0;
}
</style>
